// board.h
//  Board class

#define ADD_BOARD(char) \
	char* The##char = new char; \
	uint32_t char##ID = Board::RegisterBoard(The##char)

class Board
{
	public: // Public static variables
		static std::vector<Board*> boards;
		
	public: // Public static functions
		static uint32_t RegisterBoard(Board* c);
		static void StaticInitGraphics();
		static void StaticDestroy();
		static void RealToScreen(int cx, int cy, int w, int h, int inx, int iny, int& x, int& y);
		
	public: // Public variables
		uint32_t id;
		
	public: // Public functions
		Board();
		virtual ~Board()
		{ }
		
		virtual bool InitGraphics()
		{ return true; }
		
		virtual EStatus Tick(double dtime);
		
		virtual void DrawPortrait(BITMAP* dest, int x, int y, int w, int h) = 0;
		virtual void Draw(BITMAP* dest, int camx, int camy, int x, int y, int w, int h);
		virtual void GetLocationOfSquare(uint32_t snum, int& x, int& y) = 0;
};

// The end
