// gamestate.h
//  Base class for Game States

enum ETextboxMode
{
	TM_Transparent,
	TM_Filled
};

class GameState
{
	public: // Public functions
		GameState()
		{ }
		virtual ~GameState() = 0;
		virtual void Destroy()
		{ delete this; }
		
		virtual bool InitLogic()
		{ return true; }
		virtual bool InitGraphics()
		{ return true; }
		
		virtual EStatus Tick(double dtime)
		{ return S_Continue; }
		virtual void Draw(BITMAP* dest)
		{ }
};

class SubState: public GameState
{
	public: // Public variables
		bool done;
		
	public: // Public functions
		SubState();
};

class SubStateText: public SubState
{
	public: // Public variables
		std::string text;
		uint32_t len;
		double tnl;
		char* buffer;
		uint32_t pos;
		uint32_t lastword;
		uint32_t thisline;
		int x, y, w, h;
		ETextboxMode mode;
		
	public: // Public functions
		SubStateText(const char* text, int x, int y, int w, int h, ETextboxMode mode = TM_Transparent);
		virtual ~SubStateText();
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest);
};

// The end
