// menu.h
//  Menu GameState

class Menu: public GameState
{
	public: // Public static functions
		static GameState* Factory()
		{ return new Menu; }
		
	public: // Public variables
		BITMAP* gradient;
		BITMAP* fade_gradient;
		BITMAP* splash;
		enum
		{
			TitleScreen,
			MainScreen,
		} curscreen;
		uint32_t caret_position;
		bool full_redraw;
		
	public: // Public functions
		Menu(): gradient(NULL), fade_gradient(NULL), splash(NULL), curscreen(TitleScreen), caret_position(0), full_redraw(true)
		{ }
		virtual ~Menu();
		
		virtual bool InitGraphics();
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest);
};

// The end
