// pregame.h
//  PreGame GameState

class SubStateCharSelect: public SubState
{
	public: // Public variables
		uint32_t caret_position;
		uint32_t curplayerselection;
		
	public: // Public functions
		SubStateCharSelect();
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest);
};

class SubStateBoardSelect: public SubState
{
	public: // Public variables
		uint32_t caret_position;
		
	public: // Public functions
		SubStateBoardSelect();
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest);
};

class PreGame: public GameState
{
	public: // Public static functions
		static GameState* Factory()
		{ return new PreGame; }
		
	public: // Public variables
		BITMAP* fade_gradient;
		uint32_t bg_phase;
		uint32_t caret_position;
		std::string msgtext;
		SubState* textbox;
		SubStateCharSelect* charsel;
		SubStateBoardSelect* boardsel;
		enum
		{
			NumberScreen,
			CharSelectScreen,
			BoardSelectScreen,
		} curscreen;
		
	public: // Public functions
		PreGame(): fade_gradient(NULL), bg_phase(0), caret_position(0), textbox(NULL), charsel(NULL), curscreen(NumberScreen)
		{ }
		virtual ~PreGame();
		
		void EnterState(bool backward = false);
		
		virtual bool InitLogic();
		virtual bool InitGraphics();
		
		virtual EStatus Tick(double dtime);
		virtual void Draw(BITMAP* dest);
};

// The end
